﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private nativeMe As JavaObject
	Private varVoice As String
	Private varAge As Int
	Private varPitch As Float
	Private varVolume As Float
	Private varSpeakingRate As Float
	Private varPitchRange As Float
	Private varStyle As String	
	Public Voices As EnumVoices
	Public Age As AgeEnum
	Public Style As StyleEnum
	Public Gender As GenderEnum
	Private varGender As Int
	Public Locale As LocaleEnum
	Private varMbrolaBase As String
	Public UseOtherProperties As Boolean = False
End Sub

' http://stackoverflow.com/questions/14091186/java-tts-text-to-speech-speech-properties-file
'set mbrola.jar base location
Sub SetMbrolaPath(mbrolaPath As String)
	varMbrolaBase = mbrolaPath
End Sub

'get styles
Sub GetStyles() As List
	Dim xl As List
	xl.Initialize
	xl.Add("business")
	xl.Add("casual")
	xl.Add("robotic")
	xl.Add("breathy")
	xl.Sort(True)
	Return xl
End Sub

'get voices
Sub GetVoices() As List
	Dim xl As List
	xl.Initialize
	xl.Add("kevin")
	xl.Add("kevin16")
	xl.Add("mbrola_us1")
	xl.Add("mbrola_us2")
	xl.Add("mbrola_us3")
	xl.Add("alan")
	xl.Sort(True)
	Return xl
End Sub

'set the pitch
Sub SetPitch(VoicePitch As Float)
	varPitch = VoicePitch
End Sub

'set the volume
Sub SetVolume(VoiceVolume As Float)
	varVolume = VoiceVolume
End Sub

'set the speaking rate
Sub SetSpeakingRate(VoiceSpeakingRate As Float)
	varSpeakingRate = VoiceSpeakingRate
End Sub

'set the speaking rate
Sub SetPitchRange(VoicePitchRange As Float)
	varPitchRange = VoicePitchRange
End Sub

'set the speaking style between business, robotic, casual and breathy
Sub SetStyle(VoiceStyle As String)
	varStyle = VoiceStyle
End Sub

'set the gender of the voice
Sub SetGender(VoiceGender As Int)
	varGender = VoiceGender	
End Sub

'Initializes the object.
Public Sub Initialize()
	nativeMe = Me
	'initialize voices
	Voices.Initialize
	Voices.kevin = "kevin"
	Voices.kevin16 = "kevin16"
	Voices.mbrola_us1 = "mbrola_us1"
	Voices.mbrola_us2 = "mbrola_us2"
	Voices.mbrola_us3 = "mbrola_us3"
	UseOtherProperties = False
	Voices.alan = "alan"
	'Initialize the ages
	Age.Initialize
	Age.Child  = 1
	Age.DontCare = 2
	Age.MiddleAdult = 3
	Age.Neutral = 4
	Age.OlderAdult = 5
	Age.TeenAger = 6
	Age.YoungerAdult = 7
	varVoice = Voices.kevin16
	varAge = Age.MiddleAdult
	varPitch = 100
	varVolume = 1
	varSpeakingRate = 150
	varPitchRange = 10
	Style.Initialize
	Style.business = "business"
	Style.casual = "casual"
	Style.robotic = "robotic"
	Style.breathy = "breathy"
	varStyle = Style.business
	Gender.Initialize
	Gender.DontCare = 1
	Gender.Female = 2
	Gender.Male = 3
	Gender.Neutral = 4
	varGender = Gender.male
	varMbrolaBase = File.DirApp
	Locale.Initialize
	Locale.ENGLISH = "ENGLISH"
	Locale.US = "US"
	Locale.JAPAN = "JAPAN"
End Sub

'reset the variables
Sub Reset
	varPitch = 100
	varVolume = 1
	varSpeakingRate = 150
	varPitchRange = 10
	varVoice = Voices.kevin16
	varAge = Age.MiddleAdult
	varStyle = Style.business
	varGender = Gender.male
End Sub

Sub GetPitch() As Float
	Return Round2(varPitch,2)	
End Sub

Sub GetVolume() As Float
	Return Round2(varVolume,2)
End Sub

Sub GetSpeakingRate() As Float
	Return Round2(varSpeakingRate,2)
End Sub

Sub GetPitchRange() As Float
	Return Round2(varPitchRange,2)	
End Sub

'set the voice to use for the speech, you can choose between kevin and kevin16
Sub SetVoice(Voice As String)
	varVoice = Voice
End Sub

'set the age to use for the voice
Sub SetAge(VoiceAge As Int)
	varAge = VoiceAge
End Sub


'speak contents of a text file
Sub SpeakFile(dir As String, fil As String)
	Dim filContents As String = File.ReadString(dir,fil)
	Speak(filContents)	
End Sub

'speak the text passed to FreeTTS
Public Sub Speak(txt As String)
	nativeMe.RunMethod("dospeak", Array(txt,varVoice,varAge,varPitch,varPitchRange,varVolume,varSpeakingRate,varStyle,varGender,varMbrolaBase,UseOtherProperties))
End Sub

'extract the mbrola us1-us3 from the library
Sub ExtractMbrolaVoices(dir As String)
	Try
		'copy the mbrola voices out of the library
		File.Copy(File.DirAssets,"mbr301d.zip",dir,"mbr301d.zip")
		' unzip the file contents
		modFreeTTS.ac.AsyncUnZip(dir,"mbr301d.zip",dir,"unzip")
	Catch
		Log(LastException)
	End Try
End Sub

public Sub unzip_UnZipDone(CompletedWithoutError As Boolean, NbOfFiles As Int)
	Try
		' remove the zip file
		File.Delete(File.DirApp, "mbr301d.zip") 
	Catch
		Log(LastException)
	End Try
End Sub

#If Java
import javax.speech.*;
import java.util.*;
import javax.speech.synthesis.*;

    String speaktext;
	
    public void dospeak(String speak,String voicename,Integer age,Float pitch,Float pitchRange,Float volume,Float speakingRate,String style,Integer gender,String varMbrolaBase, Boolean UseOtherProperties)
    {
		if (speak == null || speak.trim().isEmpty()) return;
        speaktext=speak;
        String voiceName =voicename;
		try
        {
			//eliminate the need for speech.properties
			System.clearProperty("mbrola.base");			
			if (voiceName == "kevin") {
				System.setProperty("freetts.voices", "com.sun.speech.freetts.en.us.cmu_us_kal.KevinVoiceDirectory");
			} else if (voiceName == "kevin16") {
				System.setProperty("freetts.voices", "com.sun.speech.freetts.en.us.cmu_us_kal.KevinVoiceDirectory");
			} else if (voiceName == "alan") {
				System.setProperty("freetts.voices", "com.sun.speech.freetts.en.us.cmu_time_awb.AlanVoiceDirectory");
			} else {
				System.setProperty("mbrola.base", varMbrolaBase);
				System.setProperty("freetts.voices", "de.dfki.lt.freetts.en.us.MbrolaVoiceDirectory");
			}
			System.setProperty("FreeTTSSynthEngineCentral", "com.sun.speech.freetts.jsapi.FreeTTSEngineCentral");
			Central.registerEngineCentral("com.sun.speech.freetts.jsapi.FreeTTSEngineCentral");
			SynthesizerModeDesc desc = null;
			Synthesizer synthesizer = null;
			desc = new SynthesizerModeDesc(null,"general", Locale.US,null,null);
            synthesizer =  Central.createSynthesizer(desc);
            synthesizer.allocate();
            desc = (SynthesizerModeDesc)  synthesizer.getEngineModeDesc();
            Voice[] voices = desc.getVoices();
            Voice voice = null;
			for (int i = 0; i < voices.length; i++)
            {
				System.out.println(voices[i].getName());
				if (voices[i].getName().equals(voiceName))
                {
                    voice = voices[i];
                    break;
                }
            }
			if (UseOtherProperties == true) {
				switch (age) {
					case 1 : voice.setAge(javax.speech.synthesis.Voice.AGE_CHILD);
					case 2 : voice.setAge(javax.speech.synthesis.Voice.AGE_DONT_CARE);
					case 3 : voice.setAge(javax.speech.synthesis.Voice.AGE_MIDDLE_ADULT);
					case 4 : voice.setAge(javax.speech.synthesis.Voice.AGE_NEUTRAL);
					case 5 : voice.setAge(javax.speech.synthesis.Voice.AGE_OLDER_ADULT);
					case 6 : voice.setAge(javax.speech.synthesis.Voice.AGE_TEENAGER);
					case 7 : voice.setAge(javax.speech.synthesis.Voice.AGE_YOUNGER_ADULT);
				}
				switch (gender) {
					case 1: voice.setGender(javax.speech.synthesis.Voice.GENDER_DONT_CARE);
					case 2: voice.setGender(javax.speech.synthesis.Voice.GENDER_FEMALE);
					case 3: voice.setGender(javax.speech.synthesis.Voice.GENDER_MALE);
					case 4: voice.setGender(javax.speech.synthesis.Voice.GENDER_NEUTRAL);
				}
				voice.setStyle(style);
				//voice.setPitchShift(pitchShift);
 			}
			synthesizer.getSynthesizerProperties().setVoice(voice);
			synthesizer.resume();
			if (UseOtherProperties == true) {
				synthesizer.getSynthesizerProperties().setPitch(pitch);     
				synthesizer.getSynthesizerProperties().setVolume(volume);           
				synthesizer.getSynthesizerProperties().setSpeakingRate(speakingRate);
				synthesizer.getSynthesizerProperties().setPitchRange(pitchRange); 
			}   
		    synthesizer.speakPlainText(speaktext, null);
            synthesizer.waitEngineState(Synthesizer.QUEUE_EMPTY);
			synthesizer = null;
			//synthesizer.deallocate();
        }
        catch (Exception e)
        {
            String message = " missing speech.properties in " + System.getProperty("user.home") + "\n";
            System.out.println(""+e);
            System.out.println(message);
			e.printStackTrace();
        }
    }

#End If